###############################################################################
## Company      : 4JS
## Program      : fgldialog.4gl
## Date         : 19/07/1995
## Version      : 1.00
##
## Title        : Dialog functions for 4GL
## 07/12/1997   : Version 2.00.1a
##                 Pass the array of items to gra_winbutton function
##                 for fast input
###############################################################################

DEFINE fglgui       SMALLINT,
       fglWtkClient SMALLINT,
       loc_list     ARRAY[100] OF CHAR(100),
       nb_elt       SMALLINT,
       __open_fixc  SMALLINT


###############################################################################
##                 LOCAL FUNCTIONS
###############################################################################


###############################################################################
## FUNCTION initlist : Initialize the local array
## Parameters :
## none
## Returnings :
## none
###############################################################################

FUNCTION initlist()

  DEFINE i  SMALLINT

  FOR i = 1 TO 100
    LET loc_list[i] = NULL
  END FOR
  LET nb_elt = 0

END FUNCTION # initlist

###############################################################################
## FUNCTION extendlist : Put a list in an local array
## Parameters :
## p_list     : String containt the list 
##              Elements are separed by a pipe "|"
## Returnings :
## none
###############################################################################

FUNCTION extendlist(p_list)

  DEFINE p_list   CHAR(1024),
         i        SMALLINT,
         m        SMALLINT

  CALL initlist()
  IF NOT LENGTH(p_list) THEN
    RETURN
  END IF
  LET nb_elt = 1
  LET m = 1
  FOR i = 1 TO LENGTH(p_list)
    IF p_list[i,i] = "|" THEN
      IF nb_elt = 100 THEN
        RETURN
      END IF
      LET nb_elt = nb_elt + 1
      LET m = 1
    ELSE
      LET loc_list[nb_elt][m,m] = p_list[i,i]
      LET m = m + 1
    END IF
  END FOR
  LET loc_list[nb_elt+1]=NULL

END FUNCTION # extendlist


###############################################################################
##                 INITIALIZATION
###############################################################################

###############################################################################
## FUNCTION fgl_init4js : Initialization of the environnement variables
## Parameters :
## none
## Returnings :
## none
###############################################################################

FUNCTION fgl_init4js()

# FGLGUI is set to 0 for ASCII modus, 1 for GUI
  DEFINE err_stat smallint,
         mess,fgldir,path CHAR(128)

  LET fglgui = FGL_GETENV("FGLGUI")
  IF fglgui IS NULL THEN
    LET fglgui = 0
  END IF

  IF fglgui = 1 THEN
#    DISPLAY "4JS" at 1,1
    DISPLAY "" at 1,1
    IF status < 0 THEN
      let err_stat=status
      let mess=err_get(err_stat)
      display "fgl_init4js: error ",err_stat using "-<<<<&",": ",mess clipped
      EXIT PROGRAM 0
    END IF
    DISPLAY "" at 1,1
    #sleep 3
    LET fglWtkClient = fgl_uiretrieve("fglWtkClient")
    LET fgldir = fgl_getenv("FGLDIR")
    IF LENGTH(fgldir) = 0 THEN
      IF fglWtkClient THEN
        LET fgldir="c:/usr/fgl2c"
      ELSE
        LET fgldir="/usr/fgl2c"
      END IF
    END IF
    LET path=fgldir CLIPPED,"/etc/rsdialog.tcl"
    call fgl_uisendsource(path)
#    IF fglWtkClient THEN
#      CALL gra_resource("{}","$wtk_clientdir/rsdialog.tcl")
#    ELSE
#      CALL gra_resource("FGLDIR","etc/rsdialog.tcl")
#    END IF
  ELSE
    LET fglWtkClient = 0
  END IF

# Initialization of the array and number of element

  CALL initlist()

  LET __open_fixc = FALSE

END FUNCTION # fgl_init4js


###############################################################################
## FUNCTION fgl_WtkClient : 
## Parameters :
## none
## Returnings :
## ret        : TRUE if windows client
###############################################################################

FUNCTION fgl_WtkClient()

  IF fglWtkClient IS NULL THEN
    LET fglWtkClient = 0
  END IF
  RETURN fglWtkClient

END FUNCTION # fgl_WtkClient

###############################################################################
## FUNCTION fgl_fglgui : Gives the value of the environment variable FGLGUI
## Parameters :
## none
## Returnings :
## ret        : value of fglgui
###############################################################################

FUNCTION fgl_fglgui()

  IF fglgui IS NULL THEN
    LET fglgui = 0
  END IF
  RETURN fglgui

END FUNCTION # fgl_fglgui

###############################################################################
## FUNCTION fgl_relerc : Activates a ressource file
## Parameters :
## filename   : file to be resourced without extension
## Returnings :
## none
###############################################################################

FUNCTION fgl_resource(filename)

  DEFINE filename CHAR(14),
         filepath CHAR(100)

  IF NOT LENGTH(filename) OR NOT fglgui THEN
    RETURN
  END IF
  
  LET filepath = filename CLIPPED, ".tcl"
  CALL gra_resource("FGLRESDIR",filepath)

END FUNCTION # fgl_resource

###############################################################################
##                 DIALOGS MANAGEMENT
###############################################################################

###############################################################################
## FUNCTION fgl_fixedcomment : Put a comment always at the same place
## Parameters :
## p_mess     : Message to be displayed
## Returnings :
## none
###############################################################################

FUNCTION fgl_fixedcomment(p_mess)

  DEFINE p_mess  CHAR(100),
         l,nc    SMALLINT
         

#  IF fglgui = 0 THEN
    IF NOT __open_fixc THEN
      LET l  = 24-1
      LET nc = 80-1
      OPEN WINDOW __fixc AT l,1 WITH 1 ROWS,nc COLUMNS
      LET __open_fixc = TRUE
    ELSE
      CURRENT WINDOW IS __fixc
      CLEAR WINDOW __fixc
    END IF
    DISPLAY p_mess CLIPPED AT 1,1
    RETURN
#  END IF

#  CALL gra_fixedcomment(p_mess)

END FUNCTION # fgl_fixedcomment

###############################################################################
## FUNCTION fgl_winbutton : Buttons dialog window
## Parameters :
## p_title    : Title of the window ( only for graphic )
## p_mess     : Message to be displayed
## p_ans      : Default answer
## p_items    : List of the possibility of answers in a string separed by "|"
## p_icon     : an Icon name of following list or "":
##                 info
##                 exclamation
##                 stop
##                 question
## p_dang     : ( only for X11 ) Dangerous answer 0 No dangerous
##                                                1 for the first, 
##                                                2 for the second
##                                                .
##                                                .
## Returnings :
## p_ans      : answer or NULL when problem
###############################################################################

FUNCTION fgl_winbutton(p_title,p_mess,p_ans,p_items,p_icon,p_dang)

  DEFINE p_title CHAR(30),
         p_mess  CHAR(4096),
         p_items CHAR(512),
         x,
         p_dang  SMALLINT,
         p_icon  CHAR(30),
         p_ans   CHAR(80)

  CALL extendlist(p_items)
  IF nb_elt = -1 THEN
    LET p_ans = NULL
    RETURN p_ans
  END IF

  if p_dang > nb_elt then
    let p_dang = 0
  end if

  IF NOT fglgui THEN
    ERROR "This function can be use only in graphical modus"
    LET p_ans = NULL
    RETURN p_ans
  END IF

  IF p_icon="info" THEN
    LET p_icon="information"
  END IF

  IF p_icon != "information"
   AND p_icon != "exclamation"
   AND p_icon != "stop"
   AND p_icon != "question" THEN
    LET p_icon = NULL
  END IF

  LET p_ans = gra_winbutton(p_title,p_mess,p_ans,p_icon, p_dang, loc_list)

  RETURN p_ans

END FUNCTION # fgl_winbutton

###############################################################################
## FUNCTION fgl_winquestion : Question with 1,2 or 3 possibilities of answers
## Parameters :
## p_title    : Title of the window ( only for graphic )
## p_mess     : Message to be displayed
## p_ans      : Default answer
## p_items    : List of the possibility of answers in a string separed by "|"
##                 yes|no
##                 yes|no|cancel
##                 ok (default if p_items="")
##                 ok|cancel
##                 retry|cancel
##                 abort|retry|ignore
##              List can be in english, german or french
## p_icon     : an Icon name of following list or "":
##                 info
##                 exclamation
##                 stop
##                 question
## p_dang     : Dangerous answer 0 No dangerous
##                               1 for the first, 
##                               2 for the second
##                               3 for the third ( only for X11 )
## Returnings :
## p_ans      : answer or NULL when problem
###############################################################################

FUNCTION fgl_winquestion(p_title,p_mess,p_ans,p_items,p_icon,p_dang)

  DEFINE p_title CHAR(30),
         p_mess  CHAR(4096),
         x,
         p_dang  SMALLINT,
         p_icon  CHAR(30),
         p_ans   CHAR(80),
         p_items CHAR(80),
         curritem CHAR(80),
         tmp_def SMALLINT,
         citem   ARRAY[3] OF CHAR(30)

  CALL extendlist(p_items)
  IF nb_elt = -1 THEN
    LET p_ans = NULL
    RETURN p_ans
  END IF

  IF NOT fglgui THEN
    WHILE TRUE
      PROMPT p_mess CLIPPED FOR CHAR p_ans
      IF p_ans IS NOT NULL AND ( p_ans = loc_list[1] OR p_ans = loc_list[2] 
       OR p_ans = loc_list[3] ) THEN
        EXIT WHILE
      END IF
    END WHILE
    RETURN p_ans
  END IF

  FOR x = 1 TO nb_elt
    LET citem[x] = NULL
  END FOR

  LET tmp_def = 1
  CASE
    WHEN p_ans is NULL
      LET tmp_def = 1
    WHEN p_ans = loc_list[2]
      LET tmp_def = 2
    WHEN p_ans = loc_list[3]
      LET tmp_def = 3
  END CASE

  IF fglWtkClient = 1 THEN
    IF p_ans is NULL THEN
      LEt p_ans=loc_list[1]
    END IF
    LEt p_ans=UPSHIFT(p_ans)
    FOR x = 1 TO nb_elt
      LET curritem = UPSHIFT(loc_list[x])
      CASE
        WHEN curritem = "JA" OR curritem = "OUI" OR curritem="YES"
          IF p_ans = curritem THEN
            LET tmp_def=1
          END IF
          LET citem[1] = "yes"
        WHEN curritem = "NO" OR curritem = "NEIN" OR curritem="NON"
          IF p_ans = curritem THEN
            LET tmp_def=2
          END IF
          LET citem[2] = "no"
        WHEN curritem = "OK"
          LET citem[1] = "ok"
          IF p_ans = curritem THEN
            LET tmp_def=1
          END IF
        WHEN curritem = "CANCEL" OR curritem = "INTERROMPRE"
            OR curritem="UNTERBRECHEN" OR curritem="INTERRUPT"
            OR curritem="ANNULER"
          LET citem[x] = "cancel"
        WHEN curritem = "WIEDERHOLEN" OR curritem = "REPETER"
            OR curritem="RETRY"
          LET citem[x] = "retry"
        WHEN curritem = "IGNORER" OR curritem = "IGNORE"
            OR curritem="UEBERGEHEN" OR curritem="BERGEHEN"
          LET citem[3] = "ignore"
          IF p_ans = curritem THEN
            LET tmp_def=3
          END IF
        WHEN curritem = "ABANDON" OR curritem = "ABORT"
            OR curritem="ABBRECHEN"
          LET citem[1] = "abort"
          IF p_ans = curritem THEN
            LET tmp_def=1
          END IF
        OTHERWISE
          ERROR "Bad option in function winquestion:", loc_list[1]
          let p_ans=NULL
          RETURN p_ans
      END CASE
    END FOR
  ELSE
    FOR x = 1 TO nb_elt
      LET citem[x] = loc_list[x]
    END FOR
  END IF

  IF p_icon="info" THEN
    LET p_icon="information"
  END IF

  IF p_icon != "information"
   AND p_icon != "exclamation"
   AND p_icon != "stop"
   AND p_icon != "question" THEN
    LET p_icon = NULL
  END IF

  LET p_ans = gra_winquestion(p_title,p_mess,tmp_def,p_icon,
                         p_dang, citem[1], citem[2],citem[3])


  IF fglWtkClient = 1 THEN
    FOR x = 1 TO nb_elt
      IF p_ans = citem[x] THEN
        RETURN loc_list[x]
      END IF
    END FOR
  ELSE
    RETURN p_ans
  END IF

  RETURN loc_list[1]

END FUNCTION # fgl_winquestion

###############################################################################
## FUNCTION fgl_winmessage : Construct a message with one button
## Parameters :
## p_title    : Title of the window ( only for graphic )
## p_mess     : Message to be displayed
## p_icon     : Icon in the next list or "":
##                 info
##                 exclamation
##                 stop
##                 question
## Returnings :
## none
###############################################################################

FUNCTION fgl_winmessage(p_title,p_mess,p_icon)

  DEFINE p_title CHAR(30),
         p_mess  CHAR(4096),
         p_icon  CHAR(30),
         l_ans   CHAR(1)

  IF NOT fglgui THEN
    IF LENGTH(p_mess) THEN
      PROMPT p_mess CLIPPED FOR CHAR l_ans
    ELSE
      PROMPT "" FOR CHAR l_ans
    END IF
    RETURN
  END IF

# Graphic part

  IF p_icon="info" THEN
    LET p_icon="information"
  END IF

  IF p_icon != "information"
   AND p_icon != "exclamation"
   AND p_icon != "stop"
   AND p_icon != "question" THEN
    LET p_icon = NULL
  END IF

  LET l_ans = gra_winquestion(p_title,p_mess,1,p_icon,
                              "", "","","")

END FUNCTION # fgl_winmessage

###############################################################################
## FUNCTION fgl_winwait : Wait of a key with a message
## Parameters :
## p_mess     : Message to be displayed
## Returnings :
## none
###############################################################################

FUNCTION fgl_winwait(p_mess)

  DEFINE p_mess   CHAR(100),
         p_l      SMALLINT,
         p_c      SMALLINT,
         p_win    SMALLINT,
         l_ans    CHAR(1),
         l_lg     SMALLINT

  IF NOT fglgui THEN
    LET l_lg = LENGTH(p_mess)
    IF p_win AND p_l AND p_c AND l_lg THEN
      OPEN WINDOW w_wait AT p_l,p_c                   
         WITH 1 ROWS, l_lg COLUMNS                    
         ATTRIBUTE (BORDER)
#      DISPLAY p_mess CLIPPED AT 1,1
      IF NOT LENGTH(p_mess) THEN
        PROMPT "" FOR CHAR l_ans
      ELSE
        PROMPT p_mess CLIPPED FOR CHAR l_ans
      END IF
      CLOSE WINDOW w_wait
    ELSE
      IF NOT LENGTH(p_mess) THEN
        PROMPT "" FOR CHAR l_ans
      ELSE
        PROMPT p_mess CLIPPED FOR CHAR l_ans
      END IF
    END IF
    RETURN 
  END IF

  LET l_ans = gra_winquestion("",p_mess,1,"",
                              "", "","","")
END FUNCTION # fgl_winwait

###############################################################################
## FUNCTION fgl_winlist : Construct a list with a selection 
## Parameters :
## p_title    : title of the window
## p_nbl_disp : Number of displayed lines
## p_lines    : Lines separated by "|"
## Returnings :
## p_ret      : Index of the choosed line or 0 if interrupt, NULL when problem
###############################################################################

FUNCTION fgl_winlist(p_title,p_nbl_disp,p_lines)

  DEFINE p_title    CHAR(100),
         p_nbl_disp SMALLINT,
         p_lines    CHAR(4096),
         p_ret      SMALLINT,
         i          SMALLINT

    ERROR "Not implemented yet"
    LET p_ret = NULL
    RETURN p_ret
  IF NOT fglgui THEN
    ERROR "Not implemented for ASCII modus"
    LET p_ret = NULL
    RETURN p_ret
  END IF

  IF NOT LENGTH(p_lines) THEN
    RETURN 0
  END IF

  CALL extendlist(p_lines)
  IF nb_elt = -1 THEN
    LET p_ret = NULL
    RETURN p_ret
  END IF

  CALL set_count(nb_elt)

  DISPLAY ARRAY loc_list TO fgl_pulldown.*
  LET i = arr_curr()

  RETURN loc_list[i]
  
END FUNCTION # fgl_winlist

###############################################################################
## FUNCTION fgl_winprompt : Set a prompt
## Parameters :
## p_l        : Position x
## p_c        : Position y
## p_mess     : Message before the prompt value
## p_ans      : Default value for the answer (not used yet)
## p_lg       : length of input
## p_vartype  : Type of variable:
##                 0 CHAR
##                 1 SMALLINT
##                 2 INTEGER
##                 7 DATE
##               255 CHAR INVISIBLE
## Returnings :
## p_ans      : Answer
###############################################################################

FUNCTION fgl_winprompt(p_l,p_c,p_mess,p_ans,p_lg,p_vartype)

  DEFINE p_l       SMALLINT,
         p_c       SMALLINT,
         p_mess    CHAR(100),
         p_ans     CHAR(100),
         p_lg      SMALLINT,
         p_vartype SMALLINT,
         lgtot     INTEGER,
         lgmess    INTEGER,
         newstr    CHAR(100),
         newint    INTEGER,
         newdate   DATE,
         newsma    SMALLINT,
         endinput  SMALLINT,
         disp      CHAR(512),
         errstatus SMALLINT

            
  IF p_vartype != 1
   AND p_vartype != 2
   AND p_vartype != 0
   AND p_vartype != 255
   AND p_vartype != 7 THEN
    LET newstr = NULL
    ERROR "promptat: Unkwon type"
    RETURN newstr
  END IF


 LET lgmess = LENGTH(p_mess)

 LET lgtot = LENGTH(p_mess) + p_lg

 OPEN WINDOW __prompt AT p_l, p_c WITH 1 ROWS, lgtot COLUMNS ATTRIBUTE(BORDER)

 LET endinput = FALSE
 WHILE NOT endinput
   WHENEVER ERROR CONTINUE
   
   CASE
     WHEN p_vartype = 1
       PROMPT p_mess CLIPPED ATTRIBUTE(normal) FOR newsma
         ON KEY(ACCEPT)
           LET endinput = FALSE
       END PROMPT
     WHEN p_vartype = 2
       PROMPT p_mess CLIPPED ATTRIBUTE(normal) FOR newint
         ON KEY(ACCEPT)
           LET endinput = FALSE
       END PROMPT
     WHEN p_vartype = 0
       PROMPT p_mess CLIPPED ATTRIBUTE(normal) FOR newstr
         ON KEY(ACCEPT)
           LET endinput = FALSE
       END PROMPT
     WHEN p_vartype = 7
       PROMPT p_mess CLIPPED ATTRIBUTE(normal) FOR newdate
         ON KEY(ACCEPT)
           LET endinput = FALSE
       END PROMPT
     WHEN p_vartype = 255
       PROMPT p_mess CLIPPED ATTRIBUTE(normal) FOR newstr ATTRIBUTE(invisible)
         ON KEY(ACCEPT)
           LET endinput = FALSE
       END PROMPT
   END CASE
   LET errstatus = status
   WHENEVER ERROR STOP
   IF int_flag THEN
     LET endinput = TRUE
   ELSE
     IF errstatus < 0 THEN
       LET disp = err_get(errstatus)
       ERROR disp CLIPPED
     ELSE
       LET endinput = TRUE
     END IF
   END IF
 END WHILE

 CLOSE WINDOW __prompt
 
 CASE
   WHEN p_vartype = 1
     RETURN newsma
   WHEN p_vartype = 2
     RETURN newint
   WHEN p_vartype = 0
     RETURN newstr
   WHEN p_vartype = 7
     RETURN newdate
   WHEN p_vartype = 255
     RETURN newstr
   OTHERWISE
     LET newstr = NULL
     ERROR "promptat: Unknown type"
     RETURN newstr
 END CASE

 RETURN newint

END FUNCTION # fgl_winprompt 

###############################################################################
## FUNCTION date1 : Return a date from a DATETIME
## Parameters :
## d1         : date
## Returnings :
## d1         : date
###############################################################################

FUNCTION date1(d1)
  DEFINE d1 DATE
  RETURN d1
END FUNCTION

###############################################################################
## FUNCTION time1 : Return the time (hh:mm:ss) from a DATETIME
## Parameters :
## t1         : time
## Returnings :
## t1         : time
###############################################################################

FUNCTION time1(t1)
  DEFINE t1 DATETIME HOUR TO SECOND
  RETURN t1
END FUNCTION

###############################################################################
## FUNCTION ord : Evaluates the first character of a passed character
##                string argument as the corresponding integer number
## Parameters :
## c          : string
## Returnings :
## integer    : integer value of the first character
###############################################################################

FUNCTION ord(c)

  DEFINE c CHAR(1),
         i INTEGER

  LET i = fgl_keyval(c)
  IF i < 0 THEN
    LET i = i + 256
  END IF

  IF i < 0 AND i > 255 THEN
    LET i = NULL
  END IF

  RETURN i

END FUNCTION
