use channel

MAIN
  DEFINE 
    config  ARRAY[1000] OF CHAR(80),
    fontsel ARRAY[1000] OF CHAR(80),
    n,i,nbline INTEGER,
    infile,outfile CHAR(20),
    outname CHAR(80),
    LINE CHAR(200),
    filepath CHAR(64),
    oldfont  SMALLINT,
    fglgui   SMALLINT

  DEFER INTERRUPT
  #################
  # Verifications #
  #################
  LET fglgui = fgl_getenv("FGLGUI")
  IF fglgui IS NULL THEN
    LET fglgui = 0
  END IF
  IF fglgui = 4 THEN
    ERROR "This program can be run only in X11 or ASCII mode!"
    SLEEP 3
    EXIT PROGRAM 1
  END IF
  ###############################
  # Read existing configuration #
  ###############################
  LET outname = fgl_getenv("HOME"),"/.fgl2crc"

  LET infile="f1"

  WHENEVER ERROR CONTINUE

  CALL channel::open_file(infile,outname,"r")
  LET nbline = 0

  WHENEVER ERROR STOP

  IF status = 0 THEN
    WHILE(channel::read(infile,[config[nbline+1]])) 
      LET nbline=nbline+1
      IF nbline = 1000 THEN
        EXIT WHILE
      END IF
    END WHILE
    CALL channel::close(infile)
  END IF

  ###########################################
  # Search existing font line configuration #
  ###########################################
  LET oldfont = -1
  FOR i = 1 TO nbline
    IF config[i] MATCHES "\*font:*" THEN
      LET oldfont = i
      EXIT FOR
    END IF
  END FOR

  IF oldfont = -1 THEN
    LET nbline  = nbline + 1
    LET oldfont = nbline
  END IF

  ########################################
  # Read existing font on the X11 system #
  ########################################
  LET infile="pipe1"
  CALL channel::open_pipe(infile,"xlsfonts","r")

  LET n=0
  WHILE(channel::read(infile,[fontsel[n+1]])) 
    LET n=n+1
    IF n = 1000 THEN
      EXIT WHILE
    END IF
  END WHILE
    
  ############################
  # Display and Choose fonts #
  ############################
  LET filepath = fgl_getenv("FGLDIR")

  IF NOT LENGTH(filepath) THEN
    LET filepath = "/usr/fgl2c"
  END IF

  LET filepath = filepath CLIPPED,"/src/fglfontsel"
  OPEN WINDOW fontsel AT 1,1 WITH FORM filepath

  DISPLAY "aAbBcDeEfFgGhH" TO font
  DISPLAY outname TO FILE

  LET i= -1
  CALL set_count(n)
  DISPLAY ARRAY fontsel TO LINES.*          
    ON KEY(f1)
      LET i = arr_curr()
      LET LINE = ".",fgl_getpid() using "<<<<<&",
                 ".",fgl_getpid() using "<<<<<&",
                 ".fontsel.efont_0 configure -font ",fontsel[i] 
      CALL fgl_uisendcommand(LINE)
      LET LINE = ".",fgl_getpid() using "<<<<<&",
                 ".",fgl_getpid() using "<<<<<&",
                 ".fontsel.efont_21_0 configure -font ",fontsel[i] 
      CALL fgl_uisendcommand(LINE)
      LET LINE = ".",fgl_getpid() using "<<<<<&",
                 ".",fgl_getpid() using "<<<<<&",
                 ".fontsel.efont_23_0 configure -font ",fontsel[i] 
      CALL fgl_uisendcommand(LINE)
  END DISPLAY

  CLOSE WINDOW fontsel

  LET i = arr_curr()
  ###########################
  # Rewrite the config file #
  ###########################
  IF (NOT int_flag AND i>0 AND i<=n) THEN
    LET config[oldfont] = "*font: ",fontsel[i]
    LET outfile="f2"
    CALL channel::set_delimiter(outfile,"")
    CALL channel::open_file(outfile,outname,"w")
    FOR i = 1 TO nbline
      CALL channel::write(outfile,[config[i]])
    END FOR
    CALL channel::close(outfile)
  END IF

END MAIN
